
// Written by Hans de Nivelle, Dec. 2014.
// Removed template parametrization in May 2015,
// because it was good for nothing.

#ifndef GEOMETRIC_FINDFALSE_INCLUDED
#define GEOMETRIC_FINDFALSE_INCLUDED  1

#include "subststack.h"
#include "index/simple.h" 
#include "set.h"
#include "false_instance_set.h"
#include "interpretation.h"

namespace geometric
{

   void check_rhs( const rule& r, 
        const subst<element> & inst, 
        const interpretation & intp,
        false_instance_set& solutions, size_t& solutioncounter );


   void findfalse( const indexedrule& from, 
                   size_t level, 
                   const interpretation & intp,
                   subststack<element> & subst, 
                   false_instance_set& solutions, 
                   size_t& solutioncounter );


   void findfalse( const indexedrule& from,
                   const interpretation& intp,
                   false_instance_set& solutions );

   
   false_instance_set 
   findconflict( const std::vector< indexedrule > & conflicts,
                 const interpretation& intp, size_t maxsol );

   false_instance_set
   findfalse( const rulesystem& rs, 
              const interpretation& intp, size_t maxsol );
 
}

#endif


